/*
 * Dbase.h - header file for class Dbase
 * Copyright (c) 1999 Joe Yandle <yandle@cs.unc.edu>
 *
 * Dbase is an abstract class that declares the functions a database
 * should be able to perform, in an implementation independent way.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

#ifndef DBASE_H
#define DBASE_H

#include <time.h>

class Dbase
{
 public:
    virtual bool openDbase()=0;
    virtual bool queryHead(char* field, char* value)=0;
    virtual bool queryMessage(char* subj, char* from, char* date, char* time)=0;
    virtual bool queryAttach(char* subj, char* from, char* date, char* time)=0;
    virtual bool queryFolders()=0;
    virtual char* getMailAddr()=0;
    virtual void setMailAddr(char* mailAddr)=0;
    virtual char** getRow()=0;
    virtual bool moreRow()=0;
    virtual void add(char* folder, char* subject, char* from, char* to, char* mdate, char* mtime, char* headers, char* message, char* viewable)=0;
    virtual void addAttach(char* folder, char* subject, char* from, char* to, char* mdate, char* mtime, char* attachment, char* contentType, char* contentEncoding)=0;
    virtual void getDate(time_t t, char* buffer)=0;
    virtual void update(char* key1, char* val1, char* key2, char* val2)=0;
    virtual void deleteMessage(char* subj, char* from, char* date, char* time)=0;
    virtual void changeFolder(char* newFolder, char* subject, char* from, char* mdate, char* mtime)=0;
    virtual void addFolder(char* newFolder)=0;
    virtual void renameFolder(char* oldFolder, char* newFolder)=0;
    virtual void deleteFolder(char* folder)=0;
 protected:
    char* userName;
};

#endif
