/*
 * GtkMessageWin.h - header file for class GtkMessageWin
 * Copyright (c) 1999 Joe Yandle <yandle@cs.unc.edu>
 *
 * GtkMessageWin
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

#ifndef GTKMESSAGEWIN_H
#define GTKMESSAGEWIN_H

#include "Model.h"
#include <gtk--.h>

class GtkMessageWin : public Gtk_Window
{
 public:
    GtkMessageWin(Model* m);
    
    gint delete_event_impl(GdkEventAny *);
 protected:

    void addHelpMenu();
    void fileCallback(string s);
    void folderCallback(string s);
    void messageCallback(string s);
    void optionsCallback(string s);
    void helpCallback(string s);
    
    void messageComposeCallback() ;
    void destroy();
    void killWidget(Gtk_Widget* data);
    int killWidgetCallback(Gtk_Widget* data);
    void display(char* msg1, char* msg2, double pause);
    void displayAbout();
    void resetList();  
    
    Gtk_MenuBar* menuBar;  
    Gtk_Menu* fileMenu;
    Gtk_Menu* folderMenu;
    Gtk_Menu* messageMenu;
    Gtk_Menu* helpMenu;
    
    Gtk_MenuItem* fileItem;
    Gtk_MenuItem* folderItem;
    Gtk_MenuItem* messageItem;
    Gtk_MenuItem* helpItem;
    
    Gtk_MenuItem* fileExitItem;
    Gtk_MenuItem* folderRenameItem;
    Gtk_MenuItem* messageComposeItem;
    Gtk_MenuItem* helpAboutItem;
    
    Gtk_VBox* vbox;
    Gtk_HBox* hbox;
    
    Gtk_ScrolledWindow* messageWin;
    Gtk_Text* messageText;
    
    Gtk_AccelGroup* accelGroup;
    Gtk_ItemFactory_MenuBar* itemFactory;
    
    Model* model;
};

#endif
