/*
 * GtkProgressWin.C - source file for class GtkProgressWin
 * Copyright (c) 1999 Joe Yandle <yandle@cs.unc.edu>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

#include "Model.h"
#include "utils.h"
#include "GtkProgressWin.h"

#include <string.h>
#include <stdio.h>
#include <time.h>

const int BSIZE=1024;

/*
  GtkProgressWin::GtkProgressWin(Model* m) - 
*/
GtkProgressWin::GtkProgressWin(Model* m) : Gtk_Window()
{
    model=m;
    
    //set_default_size(200, 100);
    set_title("gtkmail");
    set_policy(TRUE,TRUE,FALSE);
    set_position(GTK_WIN_POS_CENTER);
    
    vbox = new Gtk_VBox(FALSE,0);
    add(*vbox);
    
    hbox = new Gtk_HBox(FALSE,0);
    label = new Gtk_Label();
    progbar = new Gtk_ProgressBar();
    table = new Gtk_Table(2,1,FALSE);
    table->attach(*label, 0, 1, 0, 1, 0, 0, 0, 5);
    table->attach(*progbar, 0, 1, 1, 2, (GTK_FILL | GTK_EXPAND),(GTK_FILL | GTK_EXPAND), 0, 5);

    vbox->pack_start(*hbox, FALSE, FALSE, 15);
    hbox->pack_start(*table, FALSE, FALSE, 20);

    show_all();
}

/*
  GtkProgressWin::~GtkProgressWin() - 
*/
GtkProgressWin::~GtkProgressWin()
{
    label->hide();
    delete label;

    progbar->hide();
    delete progbar;

    table->hide();
    delete table;

    hbox->hide();
    delete hbox;

    vbox->hide();
    delete vbox;
}

/*
  void setText(char* text)
*/
void GtkProgressWin::setText(char* text)
{
    label->set_text(text);
}

/*
  void setPct(double pct);
*/
void GtkProgressWin::setPct(double pct)
{
    progbar->set_percentage(pct);
}
