/*
 * GtkReadWin.h - header file for class GtkReadWin
 * Copyright (c) 1999 Joe Yandle <yandle@cs.unc.edu>
 *
 * GtkReadWin
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

#ifndef GTKREADWIN_H
#define GTKREADWIN_H

#include <gtk--.h>
#include "GtkMessageWin.h"

class GtkReadWin : public GtkMessageWin
{
 public:
    GtkReadWin(Model* m, char* subj, char* from, char* date, char* time, char* headers, char* viewable);
    virtual ~GtkReadWin();
 protected:
    void messageCallback(string s);
    void messageReplyCallback();
    void attachCallback(string s);
    void attachViewTextCallback();
    void attachViewImageCallback();
    void attachExportCallback();
    void attachExportUpdate(Gtk_FileSelection* fileSel);

    Gtk_Combo* attachCombo;
    Gtk_Entry *subjEntry, *fromEntry, *dateEntry, *timeEntry;
    Gtk_Table* headerTable;
    Gtk_Label *subjLabel, *fromLabel, *dateLabel, *timeLabel, *attachLabel;
    Gtk_HBox* headerHBox;
    
    Gtk_HBox* attachLabelHBox;
    Gtk_HBox* attachComboHBox;
    Gtk_HBox* subjLabelHBox;
    Gtk_HBox* fromLabelHBox;
    Gtk_HBox* dateLabelHBox;
    Gtk_HBox* timeLabelHBox;
    Gtk_HBox* subjEntryHBox;
    Gtk_HBox* fromEntryHBox;
    Gtk_HBox* dateEntryHBox;
    Gtk_HBox* timeEntryHBox;

    GList* attachList;
    int attachNum;
    
};

#endif
