/*
 * GtkWriteWin.h - header file for class GtkWriteWin
 * Copyright (c) 1999 Joe Yandle <yandle@cs.unc.edu>
 *
 * GtkWriteWin
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

#ifndef GTKWRITEWIN_H
#define GTKWRITEWIN_H

#include <gtk--.h>
#include "GtkMessageWin.h"

class GtkWriteWin : public GtkMessageWin
{
 public:
    GtkWriteWin(Model* m);
    ~GtkWriteWin();
    void setTo(char* to);
    void setSubject(char* to);
    
 protected:
    void messageCallback(string s);
    void attachCallback(string s);
    void attachFileCallback();
    void attachFileUpdate(Gtk_FileSelection* fileSel);
    void messageSendCallback();
    void escapeQuote(char* dst, char* src);
    
    Gtk_Entry *subjEntry, *toEntry;
    Gtk_MenuItem* messageSendItem;
    Gtk_Label *subjLabel, *toLabel, *attachLabel;

    Gtk_HBox* headerHBox;
    Gtk_HBox* subjLabelHBox;
    Gtk_HBox* subjEntryHBox;
    Gtk_HBox* toLabelHBox;
    Gtk_HBox* toEntryHBox;
    Gtk_HBox* attachLabelHBox;
    Gtk_HBox* attachComboHBox;

    
    Gtk_Table* headerTable;

    Gtk_Combo* attachCombo;
    GList* attachList;
    int numAttach;
};

#endif
