/*
 * MysqlDbase.C - source file for class MysqlDbase
 * Copyright (c) 1999 Joe Yandle <yandle@cs.unc.edu>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

#include "MysqlDbase.h"

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

char* dbase = "gtkmail";
/*
  char* createMessage = "CREATE TABLE messages ( userName varchar(255) binary, folder varchar(255) binary, msubject blob, mfrom blob, mto blob, mdate date, mtime time, headers blob, message longblob, viewable longblob, INDEX messageIdx (userName, folder) )";
  char* createFolder = "CREATE TABLE folders ( userName varchar(255) binary, folderName varchar(255) binary, INDEX folderIdx (userName))";
  char* createConfig = "CREATE TABLE config ( userName varchar(255) binary, mailAddr blob, INDEX configIdx (userName))";
  char* createAttach = "CREATE TABLE attach ( userName varchar(255) binary, folder varchar(255) binary, msubject blob, mfrom blob, mto blob, mdate date, mtime time, attachment longblob, type blob, encoding blob, INDEX attachIdx (userName, folder))";
*/
char* createMessage = "CREATE TABLE messages ( userName varchar(255) binary, folder varchar(255) binary, msubject blob, mfrom blob, mto blob, mdate date, mtime time, headers blob, message longblob, viewable longblob )";
char* createFolder = "CREATE TABLE folders ( userName varchar(255) binary, folderName varchar(255) binary)";
char* createConfig = "CREATE TABLE config ( userName varchar(255) binary, mailAddr blob)";
char* createAttach = "CREATE TABLE attach ( userName varchar(255) binary, folder varchar(255) binary, msubject blob, mfrom blob, mto blob, mdate date, mtime time, attachment longblob, type blob, encoding blob)";

const int BSIZE=1024;

/*
  MysqlDbase();
*/
MysqlDbase::MysqlDbase()
{
    userName = new char[255];
    strcpy(userName, getenv("USER"));
}

bool MysqlDbase::openDbase()
{
    queryRet=NULL;
    
    if((sock=mysql_connect(NULL, "localhost", "root", NULL)) == NULL) {
	return false;
    }  
    
    mysql_create_db(sock, dbase);
    
    if(mysql_select_db(sock,dbase) == -1) {
	return false;
    }
    mysql_query(sock,createMessage);
    mysql_query(sock,createFolder);
    mysql_query(sock,createConfig);
    mysql_query(sock,createAttach);

    return true;
}

/*
  virtual char* getMailAddr()=0;
*/
char* MysqlDbase::getMailAddr()
{
    char command[256];
    
    sprintf(command, 
	    "SELECT mailAddr FROM config WHERE userName = '%s'", userName);
    
    if( queryRet ) {
	mysql_free_result(queryRet);
    }
    mysql_query(sock, command);
    
    if( (queryRet = mysql_store_result(sock)) != NULL) {
	numRows = mysql_num_rows(queryRet);
    }
    else {
	numRows = 0;
    }
    
    if(numRows > 0) {
	char** temp = getRow();
	return temp[0];
    }
    else {
	return NULL;
    }
}

/*
  virtual void setMailAddr(char* mailAddr)=0;
*/
void MysqlDbase::setMailAddr(char* mailAddr)
{
    char command[256];
    
    if(getMailAddr()) {
	sprintf(command, "UPDATE config SET mailAddr = '%s' WHERE userName = '%s'", mailAddr, userName);
    }
    else {
	sprintf(command, "INSERT INTO config ( userName, mailAddr ) VALUES ( '%s', '%s')", userName, mailAddr);
    }
    
    if( queryRet ) {
	mysql_free_result(queryRet);
    }
    mysql_query(sock, command);
    
    if( (queryRet = mysql_store_result(sock)) != NULL) {
	numRows = mysql_num_rows(queryRet);
    }
    else {
	numRows = 0;
    }
}


/*
  virtual bool queryHead(char* field, char* value) - 
*/
bool MysqlDbase::queryHead(char* field, char* value)
{
    char command[256];
    sprintf(command, 
	    "SELECT mdate, mtime, mfrom, msubject FROM messages WHERE userName = '%s' and %s = '%s' ORDER BY mdate, mtime",
	    userName, field, value);
    
    if( queryRet ) {
	mysql_free_result(queryRet);
    }
    mysql_query(sock, command);
    
    if( (queryRet = mysql_store_result(sock)) != NULL) {
	numRows = mysql_num_rows(queryRet);
    }
    else {
	numRows = 0;
    }
    
    return numRows;
}

/*
  bool queryMessage(char* subj, char* from, char* date, char* time) - 
*/
bool MysqlDbase::queryMessage(char* subj, char* from, char* date, char* time)
{  
    char *gsubject, *gfrom, *gmdate, *gmtime;
    
    gsubject = new char[2*strlen(subj)];
    gfrom = new char[2*strlen(from)];
    gmdate = new char[2*strlen(date)];
    gmtime = new char[2*strlen(time)];
    
    mysql_escape_string(gsubject,subj,strlen(subj));
    mysql_escape_string(gfrom,from,strlen(from));
    mysql_escape_string(gmdate,date,strlen(date));
    mysql_escape_string(gmtime,time,strlen(time));
    
    char command[BSIZE];
    sprintf(command, 
	    "SELECT headers, message, viewable FROM messages WHERE userName = '%s' AND msubject = '%s' AND mfrom = '%s' AND mdate = '%s' AND mtime = '%s'", userName, gsubject, gfrom, gmdate, gmtime);
    if( queryRet ) {
	mysql_free_result(queryRet);
    }
    
    mysql_query(sock, command);
    
    if( (queryRet = mysql_store_result(sock)) != NULL) {
	numRows = mysql_num_rows(queryRet);
    }
    else {
	numRows = 0;    
    }
    
    delete [] gsubject;
    delete [] gfrom;
    delete [] gmdate;
    delete [] gmtime;
    
    return numRows;
}

/*
  char** getRow() - 
*/
char** MysqlDbase::getRow()
{
    numRows--;
    MYSQL_ROW row = mysql_fetch_row(queryRet);
    return (char**)(row);
}


bool MysqlDbase::moreRow()
{
    return (numRows > 0);
}

/*
  void mysql_escape_string(char* src, char* dst) -
*/
void MysqlDbase::removeSQuote(char* src, char* dst)
{
    int i=0, j=0;
    
    while(src[i] != '\0') {
	if(src[i] == '\'') {
	    dst[j++]='\\';
	}
	dst[j++]=src[i++];
    }  
    dst[j]='\0';
}

/*
  virtual void addAttach(char* folder, char* subject, char* from, char* to, char* mdate, char* mtime, char* attachment);
*/
void MysqlDbase::addAttach(char* folder, char* subject, char* from, char* to, char* mdate, char* mtime, char* attachment, char* contentType, char* contentEncoding)
{
    char *gfolder, *gsubject, *gfrom, *gto, *gmdate, *gmtime, *gattachment, *gtype, *gencoding;
    
    gfolder = new char[2*strlen(folder)];
    gsubject = new char[2*strlen(subject)];
    gfrom = new char[2*strlen(from)];
    gto = new char[2*strlen(to)];
    gmdate = new char[2*strlen(mdate)];
    gmtime = new char[2*strlen(mtime)];
    gattachment = new char[2*strlen(attachment)];
    gtype = new char[2*strlen(contentType)];
    gencoding = new char[2*strlen(contentEncoding)];
    
    mysql_escape_string(gfolder,folder,strlen(folder));
    mysql_escape_string(gsubject,subject,strlen(subject));
    mysql_escape_string(gfrom,from,strlen(from));
    mysql_escape_string(gto,to,strlen(to));
    mysql_escape_string(gmdate,mdate,strlen(mdate));
    mysql_escape_string(gmtime,mtime,strlen(mtime));
    mysql_escape_string(gattachment,attachment,strlen(attachment));
    mysql_escape_string(gtype,contentType,strlen(contentType));
    mysql_escape_string(gencoding,contentEncoding,strlen(contentEncoding));
    
    char* command = new char[strlen(gfolder)+strlen(gsubject)+strlen(gfrom)+strlen(gto)+strlen(gmdate)+strlen(gmtime)+strlen(gattachment)+1024];
    
    sprintf(command, "INSERT INTO attach ( userName, folder, msubject, mfrom, mto, mdate, mtime, attachment, type, encoding ) VALUES ( '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s' )", userName, gfolder, gsubject, gfrom, gto, gmdate, gmtime, gattachment, gtype, gencoding);
    
    if( queryRet ) {
	mysql_free_result(queryRet);
    }
    mysql_query(sock, command);
    
    if( (queryRet = mysql_store_result(sock)) != NULL) {
	numRows = mysql_num_rows(queryRet);
    }
    else {
	numRows = 0;
    }
    
    delete [] command;
    delete [] gfolder;
    delete [] gsubject;
    delete [] gfrom;
    delete [] gto;
    delete [] gmdate;
    delete [] gmtime;
    delete [] gattachment;
    delete [] gtype;
    delete [] gencoding;
}


/*
  void add(char* folder, char* subject, char* from, char* to, char* mdate, char* mtime, char* headers, char* message)
*/
void MysqlDbase::add(char* folder, char* subject, char* from, char* to, char* mdate, char* mtime, char* headers, char* message, char* viewable)
{
    char *gfolder, *gsubject, *gfrom, *gto, *gmdate, *gmtime, *gheaders, *gmessage, *gviewable;
    
    gfolder = new char[2*strlen(folder)];
    gsubject = new char[2*strlen(subject)];
    gfrom = new char[2*strlen(from)];
    gto = new char[2*strlen(to)];
    gmdate = new char[2*strlen(mdate)];
    gmtime = new char[2*strlen(mtime)];
    gheaders = new char[2*strlen(headers)];
    gmessage = new char[2*strlen(message)];
    gviewable = new char[2*strlen(viewable)];
    
    mysql_escape_string(gfolder,folder,strlen(folder));
    mysql_escape_string(gsubject,subject,strlen(subject));
    mysql_escape_string(gfrom,from,strlen(from));
    mysql_escape_string(gto,to,strlen(to));
    mysql_escape_string(gmdate,mdate,strlen(mdate));
    mysql_escape_string(gmtime,mtime,strlen(mtime));
    mysql_escape_string(gheaders,headers,strlen(headers));
    mysql_escape_string(gmessage,message,strlen(message));
    mysql_escape_string(gviewable,viewable,strlen(viewable));
    
    char* command = new char[strlen(gfolder)+strlen(gsubject)+strlen(gfrom)+strlen(gto)+strlen(gmdate)+strlen(gmtime)+strlen(gheaders)+strlen(gmessage)+strlen(gviewable)+1024];
    
    sprintf(command, "INSERT INTO messages ( userName, folder, msubject, mfrom, mto, mdate, mtime, headers, message, viewable ) VALUES ( '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s' )", userName, gfolder, gsubject, gfrom, gto, gmdate, gmtime, gheaders, gmessage, gviewable);
    
    if( queryRet ) {
	mysql_free_result(queryRet);
    }
    mysql_query(sock, command);
    
    if( (queryRet = mysql_store_result(sock)) != NULL) {
	numRows = mysql_num_rows(queryRet);
    }
    else {
	numRows = 0;
    }
    
    delete [] command;
    delete [] gfolder;
    delete [] gsubject;
    delete [] gfrom;
    delete [] gto;
    delete [] gmdate;
    delete [] gmtime;
    delete [] gheaders;
    delete [] gmessage;
    delete [] gviewable;
}

/*
  void MysqlDbase::getDate(time_t t, char* buffer)
*/
void MysqlDbase::getDate(time_t t, char* buffer)
{
    strcpy(buffer, "20-Apr-1999");
}

/*
  void MysqlDbase::update(char* key1, char* val1, char* key2, char* val2)
*/
void MysqlDbase::update(char* key1, char* val1, char* key2, char* val2)
{
    char ucommand[256];
    sprintf(ucommand, "UPDATE messages SET %s = '%s' WHERE %s = '%s'", key1, val1, key2, val2);
    
    if( queryRet ) {
	mysql_free_result(queryRet);
    }
    
    mysql_query(sock,ucommand);
    
    if( (queryRet = mysql_store_result(sock)) != NULL) {
	numRows = mysql_num_rows(queryRet);
    }
    else {
	numRows = 0;;
    }
    sprintf(ucommand, "UPDATE attach SET %s = '%s' WHERE %s = '%s'", key1, val1, key2, val2);
    
    if( queryRet ) {
	mysql_free_result(queryRet);
    }
    
    mysql_query(sock,ucommand);
    
    if( (queryRet = mysql_store_result(sock)) != NULL) {
	numRows = mysql_num_rows(queryRet);
    }
    else {
	numRows = 0;;
    }
}

/*
  virtual void delete(char* subj, char* from, char* date, char* time);
*/
void MysqlDbase::deleteMessage(char* subj, char* from, char* date, char* time)
{
    char *gsubject, *gfrom, *gmdate, *gmtime;
    
    gsubject = new char[2*strlen(subj)];
    gfrom = new char[2*strlen(from)];
    gmdate = new char[2*strlen(date)];
    gmtime = new char[2*strlen(time)];
    
    mysql_escape_string(gsubject,subj,strlen(subj));
    mysql_escape_string(gfrom,from,strlen(from));
    mysql_escape_string(gmdate,date,strlen(date));
    mysql_escape_string(gmtime,time,strlen(time));
    
    char command[BSIZE];
    sprintf(command, 
	    "DELETE FROM messages WHERE %s = '%s' AND %s = '%s' AND %s = '%s' AND %s = '%s' AND %s = '%s'",
	    "userName", userName, "msubject", gsubject, "mfrom", gfrom, "mdate", gmdate, "mtime", gmtime);
    
    if( queryRet ) {
	mysql_free_result(queryRet);
    }
    
    mysql_query(sock, command);
    
    if( (queryRet = mysql_store_result(sock)) != NULL) {
	numRows = mysql_num_rows(queryRet);
    }
    else {
	numRows = 0;
    }
    
    sprintf(command, 
	    "DELETE FROM attach WHERE %s = '%s' AND %s = '%s' AND %s = '%s' AND %s = '%s' AND %s = '%s'",
	    "userName", userName, "msubject", gsubject, "mfrom", gfrom, "mdate", gmdate, "mtime", gmtime);
    
    if( queryRet ) {
	mysql_free_result(queryRet);
    }
    
    mysql_query(sock, command);
    
    if( (queryRet = mysql_store_result(sock)) != NULL) {
	numRows = mysql_num_rows(queryRet);
    }
    else {
	numRows = 0;
    }
    

    delete [] gsubject;
    delete [] gfrom;
    delete [] gmdate;
    delete [] gmtime;
}

void MysqlDbase::changeFolder(char* newFolder, char* subject, char* from, char* mdate, char* mtime)
{
    char *gfolder, *gsubject, *gfrom, *gmdate, *gmtime;
    
    gfolder = new char[2*strlen(newFolder)];
    gsubject = new char[2*strlen(subject)];
    gfrom = new char[2*strlen(from)];
    gmdate = new char[2*strlen(mdate)];
    gmtime = new char[2*strlen(mtime)];
    
    mysql_escape_string(gfolder,newFolder,strlen(newFolder));
    mysql_escape_string(gsubject,subject,strlen(subject));
    mysql_escape_string(gfrom,from,strlen(from));
    mysql_escape_string(gmdate,mdate,strlen(mdate));
    mysql_escape_string(gmtime,mtime,strlen(mtime));
    
    char command[BSIZE];
    sprintf(command, 
	    "UPDATE messages SET folder = '%s' WHERE %s = '%s' AND %s = '%s' AND %s = '%s' AND %s = '%s' AND %s = '%s'",
	    gfolder, "userName", userName, "msubject", gsubject, "mfrom", gfrom, "mdate", gmdate, "mtime", gmtime);
    
    if( queryRet ) {
	mysql_free_result(queryRet);
    }
    
    mysql_query(sock, command);
    if( (queryRet = mysql_store_result(sock)) != NULL) {
	numRows = mysql_num_rows(queryRet);
    }
    else {
	numRows = 0;
    }
    

    sprintf(command, 
	    "UPDATE attach SET folder = '%s' WHERE %s = '%s' AND %s = '%s' AND %s = '%s' AND %s = '%s' AND %s = '%s'",
	    gfolder, "userName", userName, "msubject", gsubject, "mfrom", gfrom, "mdate", gmdate, "mtime", gmtime);
    
    if( queryRet ) {
	mysql_free_result(queryRet);
    }
    
    mysql_query(sock, command);
    if( (queryRet = mysql_store_result(sock)) != NULL) {
	numRows = mysql_num_rows(queryRet);
    }
    else {
	numRows = 0;
    }
    
    delete [] gfolder;
    delete [] gsubject;
    delete [] gfrom;
    delete [] gmdate;
    delete [] gmtime;
}

/*
  virtual bool queryFolders();
*/
bool MysqlDbase::queryFolders()
{
    char command[255];
    sprintf(command, "SELECT DISTINCT folderName FROM folders WHERE userName = '%s' AND folderName like '%%'", userName);
    
    if( queryRet ) {
	mysql_free_result(queryRet);
    }
    
    mysql_query(sock,command);
    if( (queryRet = mysql_store_result(sock)) != NULL) {
	numRows = mysql_num_rows(queryRet);
    }
    else {
	numRows = 0;
    }
    return numRows;
}

/*
  virtual void addFolder(char* newFolder);
*/
void MysqlDbase::addFolder(char* newFolder)
{
    char command[255];
    sprintf(command, "INSERT INTO folders ( userName, folderName ) VALUES ( '%s', '%s' )", userName, newFolder);
    
    if( queryRet ) {
	mysql_free_result(queryRet);
    }
    
    mysql_query(sock,command);
    
    if( (queryRet = mysql_store_result(sock)) != NULL) {
	numRows = mysql_num_rows(queryRet);
    }
    else {
	numRows = 0;
    }
}

/*
  virtual void renameFolder(char* oldFolder, char* newFolder);
*/
void MysqlDbase::renameFolder(char* oldFolder, char* newFolder)
{
    char command[255];
    sprintf(command, "UPDATE folders SET folderName = '%s' WHERE userName = '%s' AND folderName = '%s'", userName, newFolder, oldFolder);
    
    if( queryRet ) {
	mysql_free_result(queryRet);
    }
    
    mysql_query(sock,command);
    
    if( (queryRet = mysql_store_result(sock)) != NULL) {
	numRows = mysql_num_rows(queryRet);
    }
    else {
	numRows = 0;
    }  
    
    
    sprintf(command, "UPDATE messages SET folder = '%s' WHERE userName = '%s' AND folder = '%s'", userName, newFolder, oldFolder);
    
    if( queryRet ) {
	mysql_free_result(queryRet);
    }
    
    mysql_query(sock,command);
    
    if( (queryRet = mysql_store_result(sock)) != NULL) {
	numRows = mysql_num_rows(queryRet);
    }
    else {
	numRows = 0;
    }  
}


/*
  virtual void deleteFolder(char* oldFolder, char* newFolder);
*/
void MysqlDbase::deleteFolder(char* folder)
{
    char command[255];
    sprintf(command, "DELETE FROM folders WHERE userName = '%s' AND folderName = '%s'", userName, folder);
    
    if( queryRet ) {
	mysql_free_result(queryRet);
    }
    
    mysql_query(sock,command);
    
    if( (queryRet = mysql_store_result(sock)) != NULL) {
	numRows = mysql_num_rows(queryRet);
    }
    else {
	numRows = 0;
    }  
    
    sprintf(command, "DELETE FROM messages WHERE userName = '%s' AND folder = '%s'", userName, folder);
    
    if( queryRet ) {
	mysql_free_result(queryRet);
    }
    
    mysql_query(sock,command);
    
    if( (queryRet = mysql_store_result(sock)) != NULL) {
	numRows = mysql_num_rows(queryRet);
    }
    else {
	numRows = 0;
    }      

    sprintf(command, "DELETE FROM attach WHERE userName = '%s' AND folder = '%s'", userName, folder);
    
    if( queryRet ) {
	mysql_free_result(queryRet);
    }
    
    mysql_query(sock,command);
    
    if( (queryRet = mysql_store_result(sock)) != NULL) {
	numRows = mysql_num_rows(queryRet);
    }
    else {
	numRows = 0;
    }      

}


/*
  virtual bool queryAttach(char* subj, char* from, char* date, char* time);
*/
bool MysqlDbase::queryAttach(char* subj, char* from, char* date, char* time)
{
    char *gsubject, *gfrom, *gmdate, *gmtime;
    
    gsubject = new char[2*strlen(subj)];
    gfrom = new char[2*strlen(from)];
    gmdate = new char[2*strlen(date)];
    gmtime = new char[2*strlen(time)];
    
    mysql_escape_string(gsubject,subj,strlen(subj));
    mysql_escape_string(gfrom,from,strlen(from));
    mysql_escape_string(gmdate,date,strlen(date));
    mysql_escape_string(gmtime,time,strlen(time));
    
    char command[BSIZE];
    sprintf(command, 
	    "SELECT type, encoding, attachment FROM attach WHERE userName = '%s' AND msubject = '%s' AND mfrom = '%s' AND mdate = '%s' AND mtime = '%s'", userName, gsubject, gfrom, gmdate, gmtime);
    if( queryRet ) {
	mysql_free_result(queryRet);
    }
    
    mysql_query(sock, command);
    
    if( (queryRet = mysql_store_result(sock)) != NULL) {
	numRows = mysql_num_rows(queryRet);
    }
    else {
	numRows = 0;    
    }
    
    delete [] gsubject;
    delete [] gfrom;
    delete [] gmdate;
    delete [] gmtime;
    
    return numRows;    
}
