/*
 * MysqlDbase.h - header file for class MysqlDbase
 * Copyright (c) 1999 Joe Yandle <yandle@cs.unc.edu>
 *
 * This class implements the abstract class Dbase, using mSQL.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

#ifndef MSQLDBASE_H
#define MSQLDBASE_H

#include "Dbase.h"
#include "mysql.h"

class MysqlDbase : public Dbase
{
 public:
    MysqlDbase();
    bool openDbase();
    virtual bool queryHead(char* field, char* value);
    virtual bool queryMessage(char* subj, char* from, char* date, char* time);
    virtual bool queryAttach(char* subj, char* from, char* date, char* time);
    virtual bool queryFolders();
    virtual char* getMailAddr();
    virtual void setMailAddr(char* mailAddr);
    char** getRow();
    bool moreRow();
    virtual void add(char* folder, char* subject, char* from, char* to, char* mdate, char* mtime, char* headers, char* message, char* viewable);
    virtual void addAttach(char* folder, char* subject, char* from, char* to, char* mdate, char* mtime, char* attachment, char* contentType, char* contentEncoding);
    virtual void getDate(time_t t, char* buffer);
    virtual void update(char* key1, char* val1, char* key2, char* val2);
    virtual void deleteMessage(char* subj, char* from, char* date, char* time);
    virtual void changeFolder(char* newFolder, char* subject, char* from, char* mdate, char* mtime);
    virtual void addFolder(char* newFolder);
    virtual void renameFolder(char* oldFolder, char* newFolder);
    virtual void deleteFolder(char* folder);
 private:
    void removeSQuote(char* src, char* dst);
    MYSQL* sock;
    int numRows;
    MYSQL_RES* queryRet;
};

#endif
