/*-*- c++ -*-********************************************************
 * wxFontManager - allocating and deallocating fonts for drawing    *
 *                                                                  *
 * (C) 1997,1998 by Karsten Ballder (Ballueder@usa.net)            *
 *                                                                  *
 * $Id: wxFontManager.cpp,v 1.3 1998/05/18 17:48:41 KB Exp $         *
 ********************************************************************
 * $Log: wxFontManager.cpp,v $
 * Revision 1.3  1998/05/18 17:48:41  KB
 * more list<>->kbList changes, fixes for wxXt, improved makefiles
 *
 * Revision 1.2  1998/03/26 23:05:41  VZ
 * Necessary changes to make it compile under Windows (VC++ only)
 * Header reorganization to be able to use precompiled headers
 *
 * Revision 1.1  1998/03/14 12:21:22  karsten
 * first try at a complete archive
 *
 *******************************************************************/

#ifdef __GNUG__
#   pragma implementation "wxFontManager.h"
#endif

#include  "Mpch.h"
#include  "Mcommon.h"

#include   "gui/wxFontManager.h"

/**
   FontManager class, this class allocates and deallocates fonts for
   the application, freeing the individual gui object from the need to
   allocate or deallocate them.
*/


wxFont *
wxFontManager::GetFont(int size, int family, int style, int weight,
                       Bool underline)
{
   kbListIterator
      i;
   FontData
      *fd;

   for(i = fontList.begin(); i != fontList.end(); i++)
   {
      fd = kbListICast(FontData,i);
      if(fd->size == size &&
         fd->family == family &&
         fd->weight == weight &&
         fd->style == style &&
         fd->underline == underline)
         return fd->fontPtr;
   }

   // not found, create:
   FontData   *newFont = new FontData;
   newFont->size = size;
   newFont->family = family;
   newFont->style = style;
   newFont->weight = weight;
   newFont->underline = underline;
   newFont->fontPtr = GLOBAL_NEW wxFont(size,family,style,weight,underline != 0);
   fontList.push_front(newFont);
   return newFont->fontPtr;
}

